package interfaces

import (
	"context"
	"io"
	"nf-repo/internal/model"
	"nf-repo/internal/util/rerr"
)

type ManifestHandler interface {
	Get(ctx context.Context, repo string, target string) (io.ReadCloser, string, *rerr.RepositoryError)
	Put(ctx context.Context, repo string, target string, digest string, mf *model.Manifest) *rerr.RepositoryError
	Delete(ctx context.Context, repo string, target string) *rerr.RepositoryError

	Catelog(ctx context.Context, limit int, last int) (*model.Catalog, *rerr.RepositoryError)
	Tags(ctx context.Context, repo string, limit, last int) (*model.Tag, *rerr.RepositoryError)
	Referrers(ctx context.Context, repo string, target string) (*model.IndexManifest, *rerr.RepositoryError)
}
